--- old	2014-11-04 10:15:35.360185856 +0100
+++ new	2014-11-04 10:15:31.805568512 +0100
@@ -1,3 +1,108 @@
+DAEMON 'DHCP':   gateway: 192.168.1.1
+DAEMON 'DHCP':   nameserver[0]: 212.27.40.240
+DAEMON 'DHCP':   nameserver[1]: 212.27.40.241
+DAEMON 'DHCP': /dev/net/ipro100/0: DHCP status = No error
+KERN: emuxki: init_hardware()
+KERN: [34musb_midi:[m init_driver() version:Nov  2 2014 01:46:21
+KERN: [34musb_midi:[m init_driver() OK
+KERN: [34musb_midi:[m publish_devices()
+KERN: [34musb_midi:[m uninit_driver()
+KERN: [34musb_midi:[m uninit complete
+KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/midi/usb_midi
+KERN: auich: init_hardware()
+KERN: auich: init_driver()
+KERN: pci_reserve_device(0, 31, 5, auich)
+KERN: auich: auich_setup(0xcdec07e0)
+KERN: auich: audio/hmulti/auich/1 deviceid = 0x2485 chiprev = 2 model = 1 enhanced at 0
+KERN: auich: IO space not configured
+KERN: auich: Setup of auich 1 failed
+KERN: pci_unreserve_device(0, 31, 5, auich)
+KERN: auich: no cards
+KERN: auich: no suitable cards found
+KERN: echo3g: init_hardware()
+KERN: echo3g: no card found
+KERN: sis7018:init_hardware:ver:2.0.2
+KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/emuxki
+KERN: auvia: init_hardware()
+KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/ice1712
+KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/bus/usb_raw
+KERN: firewire: fw_module_init
+KERN: Texas Instruments TSB43AB22/A
+KERN: vendor=104c, device=8023, revision = 0
+KERN: firewire: found 1 cards
+KERN: firewire: latency timer 40 -> 40.
+KERN: firewire: cache size 8 -> 8.
+KERN: firewire: ERROR no IRQ assigned
+KERN: firewire: ERROR fwohci_pci_attach failed
+KERN: fw_raw: couldn't load bus_managers/firewire/v1
+KERN: cx23882: init_hardware()
+KERN: devfs: reload driver "ice1712" (4, 10904)
+KERN: devfs: reload driver "emuxki" (4, 10892)
+KERN: emuxki: init_hardware()
+KERN: bfs: bfs_create_index:2124: File or Directory already exists
+--
+KERN: package_daemon [143145918:   375] CommitTransactionHandler::_ChangePackageActivation(): activating 1, deactivating 0 packages
+KERN: packagefs [143148239:   375] Volume::_ChangeActivation(): 1 new packages, 0 old packages
+KERN: packagefs [143153004:   375] package "ffmpeg-0.10.14-1-x86_gcc2.hpkg" activated
+KERN: package_daemon [143645488:   375] Volume::_PackagesEntryCreated("ffmpeg-0.10.14-1-x86_gcc2.hpkg")
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: fs_mount - EXIT, result code is No error
+KERN: [34mext2:[0m Inode::CreateFileCache(): Failed to create file cache
+KERN: slab memory manager: created area 0xd1801000 (14746)
+KERN: [34mext2:[0m Inode::CreateFileCache(): Failed to create file cache
+KERN: slab memory manager: created area 0xd2001000 (14756)
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: AudioMixer: Dequeued input buffer 58520 usec late
+KERN: AudioMixer: sending notify
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: vm_soft_fault: va 0x74756000 not covered by area in address space
+KERN: vm_page_fault: vm_soft_fault returned error 'Bad address' on fault at 0x74756200, ip 0x153bb40, write 0, user 1, thread 0x2bf
+KERN: vm_page_fault: thread "frame generator" (703) in team "MediaPlayer" (686) tried to read address 0x74756200, ip 0x153bb40 ("libroot.so_seg0ro" +0x35b40)
+KERN: debug_server: Thread 703 entered the debugger: Segment violation
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: stack trace, current PC 0x153bb40  atomic_or + 0x8:
+KERN:   (0x71f0d888)  0x20fb41a  RealTimeFor__11BTimeSourcexx + 0x42
+KERN:   (0x71f0d8d8)  0x1987837  _FrameGeneratorThread__13VideoProducer + 0x137
+KERN:   (0x71f0d968)  0x19876f7  _FrameGeneratorThreadEntry__13VideoProducerPv + 0x1f
+KERN:   (0x71f0d998)  0x1536efb  thread_entry + 0x23
+KERN: debug_server: Killing team 686 (/boot/system/apps/MediaPlayer)
+KERN: debug_server: TeamDebugHandler::Init(): Failed to get info for team 686: Operation on invalid team
+KERN: debug_server: KillTeam(): Error getting info for team 686: Operation on invalid team
+KERN: debug_server: Killing team 686 ()
+KERN: AudioMixer: Dequeued input buffer 60893 usec late
+KERN: AudioMixer: sending notify
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: runtime_loader: /boot/system/lib/x86/libavcodec.so.54.23.100: Failed to get gcc version.
+KERN: runtime_loader: /boot/system/lib/x86/libavutil.so.51.54.100: Failed to get gcc version.
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: libnetwork.so running in R5 compatibility mode.
+--
 KERN: PCI:   info: Mass storage controller (IDE interface)
 KERN: PCI:   line_size 00, latency 00, header_type 00, BIST 00
 KERN: PCI:   ROM base host 00000000, pci 00000000, size 00000000
@@ -31,13 +136,9 @@
 KERN: PCI:   vendor 8086: Intel Corporation
 KERN: PCI:   device 2486: 82801CA/CAM AC'97 Modem Controller
 --
-KERN: emuxki: init_hardware()
-KERN: [34musb_midi:[m init_driver() version:Nov  2 2014 01:04:36
-KERN: [34musb_midi:[m init_driver() OK
-KERN: [34musb_midi:[m publish_devices()
-KERN: [34musb_midi:[m uninit_driver()
-KERN: [34musb_midi:[m uninit complete
-KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/midi/usb_midi
+DAEMON 'DHCP':   nameserver[0]: 212.27.40.240
+DAEMON 'DHCP':   nameserver[1]: 212.27.40.241
+DAEMON 'DHCP': /dev/net/ipro100/0: Send DHCP_REQUEST for 192.168.1.180 to 255.255.255.255:67
 DAEMON 'DHCP': /dev/net/ipro100/0: Received DHCP_ACK from 192.168.1.1
 DAEMON 'DHCP':   server: 192.168.1.1
 DAEMON 'DHCP':   lease time: 864000 seconds
@@ -46,66 +147,70 @@
 DAEMON 'DHCP':   nameserver[0]: 212.27.40.240
 DAEMON 'DHCP':   nameserver[1]: 212.27.40.241
 DAEMON 'DHCP': /dev/net/ipro100/0: DHCP status = No error
-KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/emuxki
-KERN: echo3g: init_hardware()
-KERN: echo3g: no card found
-KERN: auvia: init_hardware()
 KERN: auich: init_hardware()
 KERN: auich: init_driver()
 KERN: pci_reserve_device(0, 31, 5, auich)
-KERN: auich: auich_setup(0xcdedb7e0)
-KERN: auich: audio/hmulti/auich/1 deviceid = 0x2485 chiprev = 2 model = 1 enhanced at ce00
-KERN: auich: PCI command before: 5
-KERN: auich: PCI command after: 5
-KERN: bfs: bfs_create_index:2124: File or Directory already exists
-KERN: Last message repeated 3 times.
-KERN: auich: codec attach
-KERN: codec reset
-KERN: auich: codec semaphore timed out!
-KERN: auich: last read/write registers: 56/0
-KERN: ac97_set_rate: clock = 48000, rate = 20000, value = 20000
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 8000, value = 8000
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 11025, value = 11025
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 12000, value = 12000
---
-KERN: ac97_set_rate failed, new rate 0
-KERN: default_init
-KERN: ac97_amp_enable, reverse eamp = 0
-KERN: powerdown register was = 0x0f
-KERN: powerdown register is = 0x0f
-KERN: codec vendor id      = 0x594d4803
-KERN: codec description     = Yamaha
-KERN: codec 3d enhancement = No 3D Stereo Enhancement
-KERN: AC97 capabilities:
-KERN: CAP_DAC_18BIT
-KERN: CAP_AMAP
-KERN: CAP_REV22
-KERN: auich: installing interrupt : b
-KERN: auich: init_driver done
-KERN: auich: publish_devices()
-KERN: auich: publish audio/hmulti/auich/1
-KERN: auich: find_device(audio/hmulti/auich/1)
-KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/auich
+KERN: auich: auich_setup(0x8145f7e0)
+KERN: auich: audio/hmulti/auich/1 deviceid = 0x2485 chiprev = 2 model = 1 enhanced at 0
+KERN: auich: IO space not configured
+KERN: auich: Setup of auich 1 failed
+KERN: pci_unreserve_device(0, 31, 5, auich)
+KERN: auich: no cards
+KERN: auich: no suitable cards found
+KERN: echo3g: init_hardware()
+KERN: echo3g: no card found
 KERN: sis7018:init_hardware:ver:2.0.2
+KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/emuxki
+KERN: auvia: init_hardware()
 KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/ice1712
-KERN: auich: set_enabled_channels 0 : enabled
-KERN: auich: set_enabled_channels 1 : enabled
-KERN: auich: set_enabled_channels 2 : enabled
-KERN: auich: set_enabled_channels 3 : enabled
-KERN: auich: name : Master
-KERN: auich: name : PCM out
-KERN: auich: name : CD
-KERN: auich: name : Aux In
-KERN: auich: name : TAD
-KERN: auich: name : Mic
-KERN: auich: name : Line in
-KERN: auich: name : Center/Lfe
-KERN: auich: name : Recording
-KERN: auich: multi->control_count 46
+KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/bus/usb_raw
+KERN: firewire: fw_module_init
+KERN: Texas Instruments TSB43AB22/A
+KERN: vendor=104c, device=8023, revision = 0
+KERN: firewire: found 1 cards
+KERN: firewire: latency timer 40 -> 40.
+KERN: firewire: cache size 8 -> 8.
+KERN: firewire: ERROR no IRQ assigned
+KERN: firewire: ERROR fwohci_pci_attach failed
+KERN: fw_raw: couldn't load bus_managers/firewire/v1
 KERN: cx23882: init_hardware()
+KERN: devfs: reload driver "ice1712" (4, 10954)
+KERN: devfs: reload driver "emuxki" (4, 10942)
+KERN: emuxki: init_hardware()
+KERN: bfs: bfs_create_index:2124: File or Directory already exists
+--
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: AudioMixer: Dequeued input buffer 30473 usec late
+KERN: AudioMixer: sending notify
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: acpi: GPE Event 8 for \_GPE
 --
 KERN: PCI:   info: Mass storage controller (IDE interface)
 KERN: PCI:   line_size 00, latency 00, header_type 00, BIST 00
@@ -127,12 +232,12 @@
 KERN: PCI:   line_size 00, latency 00, header_type 00, BIST 00
 KERN: PCI:   ROM base host 00000000, pci 00000000, size 00000000
 KERN: PCI:   cardbus_CIS 00000000, subsystem_id 0001, subsystem_vendor_id 1179
-KERN: PCI:   interrupt_line 0b, interrupt_pin 02, min_grant 00, max_latency 00
-KERN: PCI:   base reg 0: host 0000ce00, pci 0000ce00, size 00000100, flags 01
-KERN: PCI:   base reg 1: host 0000cdc0, pci 0000cdc0, size 00000040, flags 01
-KERN: PCI:   base reg 2: host 00000000, pci 00000000, size 00000000, flags 00
+KERN: PCI:   interrupt_line ff, interrupt_pin 02, min_grant 00, max_latency 00
+KERN: PCI:   base reg 0: host 00000000, pci 00000000, size 00000100, flags 01
+KERN: PCI:   base reg 1: host 00000000, pci 00000000, size 00000040, flags 01
+KERN: PCI:   base reg 2: host 00000000, pci 00000000, size KERN: 00000000, flags 00
 KERN: PCI:   base reg 3: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   base reg 4: host 00000000, pci 00000000, size 00000000,KERN:  flags 00
+KERN: PCI:   base reg 4: host 00000000, pci 00000000, size 00000000, flags 00
 KERN: PCI:   base reg 5: host 00000000, pci 00000000, size 00000000, flags 00
 KERN: PCI:   Capabilities: (not supported)
 KERN: PCI: [dom 0, bus  0] bus   0, device 31, function  6: vendor 8086, device 2486, revision 02
@@ -140,10 +245,8 @@
 KERN: PCI:   vendor 8086: Intel Corporation
 KERN: PCI:   device 2486: 82801CA/CAM AC'97 Modem Controller
 --
-DAEMON 'DHCP':   nameserver[1]: 212.27.40.241
-DAEMON 'DHCP': /dev/net/ipro100/0: DHCP status = No error
-KERN: acpi: GPE Event 8 for \_GPE
-KERN: acpi: Notify event 128 for \_SB_.BAT1
+KERN: ps2: devfs_publish_device input/keyboard/at/0, status = 0x00000000
+KERN: ps2: keyboard found
 KERN: emuxki: init_hardware()
 KERN: [34musb_midi:[m init_driver() version:Nov  2 2014 01:46:21
 KERN: [34musb_midi:[m init_driver() OK
@@ -151,45 +254,18 @@
 KERN: [34musb_midi:[m uninit_driver()
 KERN: [34musb_midi:[m uninit complete
 KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/midi/usb_midi
+KERN: acpi: GPE Event 8 for \_GPE
+KERN: acpi: Notify event 128 for \_SB_.BAT1
 KERN: auich: init_hardware()
 KERN: auich: init_driver()
 KERN: pci_reserve_device(0, 31, 5, auich)
-KERN: auich: auich_setup(0x813827e0)
-KERN: auich: audio/hmulti/auich/1 deviceid = 0x2485 chiprev = 2 model = 1 enhanced at ce00
-KERN: auich: PCI command before: 5
-KERN: auich: PCI command after: 5
-KERN: acpi: GPE Event 5 for \_GPE
-KERN: Last message repeated 187 times.
-KERN: auich: codec attach
-KERN: codec reset
-KERN: auich: codec semaphore timed out!
-KERN: auich: last read/write registers: 56/0
-KERN: ac97_set_rate: clock = 48000, rate = 20000, value = 20000
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 8000, value = 8000
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 11025, value = 11025
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 12000, value = 12000
---
-KERN: ac97_set_rate failed, new rate 0
-KERN: default_init
-KERN: ac97_amp_enable, reverse eamp = 0
-KERN: powerdown register was = 0x0f
-KERN: powerdown register is = 0x0f
-KERN: codec vendor id      = 0x594d4803
-KERN: codec description     = Yamaha
-KERN: codec 3d enhancement = No 3D Stereo Enhancement
-KERN: AC97 capabilities:
-KERN: CAP_DAC_18BIT
-KERN: CAP_AMAP
-KERN: CAP_REV22
-KERN: auich: installing interrupt : b
-KERN: auich: init_driver done
-KERN: auich: publish_devices()
-KERN: auich: publish audio/hmulti/auich/1
-KERN: auich: find_device(audio/hmulti/auich/1)
-KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/auich
+KERN: auich: auich_setup(0xcdeb07e0)
+KERN: auich: audio/hmulti/auich/1 deviceid = 0x2485 chiprev = 2 model = 1 enhanced at 0
+KERN: auich: IO space not configured
+KERN: auich: Setup of auich 1 failed
+KERN: pci_unreserve_device(0, 31, 5, auich)
+KERN: auich: no cards
+KERN: auich: no suitable cards found
 KERN: echo3g: init_hardware()
 KERN: echo3g: no card found
 KERN: sis7018:init_hardware:ver:2.0.2
@@ -203,14 +279,14 @@
 KERN: firewire: found 1 cards
 KERN: firewire: latency timer 40 -> 40.
 KERN: firewire: cache size 8 -> 8.
-KERN: firewire: IRQ 11
-KERN: firewire: hardware register address fceff800
-KERN: firewire: mapping physical address 0xfceff800 with 2048 bytes for fw ohci register
-KERN: add_memory_type_range(6887, 0xfceff000, 0x1000, 0)
-KERN: set MTRRs to:
-KERN:   mtrr:  0: base:    0xee000, size:     0x1000, type: 0
-KERN:   mtrr:  1: base: 0x4ffd0000, size:    0x10000, type: 0
-KERN:   mtrr:  2: base: 0xe0000000, size: 0x20000000, type: 0
+KERN: firewire: ERROR no IRQ assigned
+KERN: firewire: ERROR fwohci_pci_attach failed
+KERN: fw_raw: couldn't load bus_managers/firewire/v1
+KERN: cx23882: init_hardware()
+KERN: devfs: reload driver "ice1712" (4, 10954)
+KERN: devfs: reload driver "emuxki" (4, 10942)
+KERN: emuxki: init_hardware()
+KERN: acpi: GPE Event 8 for \_GPE
 --
 KERN: PCI:   info: Mass storage controller (IDE interface)
 KERN: PCI:   line_size 00, latency 00, header_type 00, BIST 00
@@ -245,63 +321,32 @@
 KERN: PCI:   vendor 8086: Intel Corporation
 KERN: PCI:   device 2486: 82801CA/CAM AC'97 Modem Controller
 --
-KERN: acpi: GPE Event 8 for \_GPE
-KERN: acpi: Notify event 128 for \_SB_.BAT1
-KERN: emuxki: init_hardware()
-KERN: [34musb_midi:[m init_driver() version:Nov  2 2014 01:46:21
 KERN: [34musb_midi:[m init_driver() OK
 KERN: [34musb_midi:[m publish_devices()
 KERN: [34musb_midi:[m uninit_driver()
 KERN: [34musb_midi:[m uninit complete
 KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/midi/usb_midi
+KERN: ps2: probe_mouse Extended PS/2 mouse found
+KERN: ps2: devfs_publish_device input/mouse/ps2/intelli_0, status = 0x00000000
+KERN: ps2: devfs_publish_device input/keyboard/at/0, status = 0x00000000
+KERN: ps2: keyboard found
 KERN: acpi: GPE Event 8 for \_GPE
-KERN: acpi: Notify event 128 for \_TZ_.THRM
+KERN: acpi: Notify event 128 for \_SB_.BAT1
 KERN: auich: init_hardware()
 KERN: auich: init_driver()
 KERN: pci_reserve_device(0, 31, 5, auich)
-KERN: auich: auich_setup(0xcdea87e0)
-KERN: auich: audio/hmulti/auich/1 deviceid = 0x2485 chiprev = 2 model = 1 enhanced at ce00
-KERN: auich: PCI command before: 5
-KERN: auich: PCI command after: 5
-KERN: acpi: GPE Event 5 for \_GPE
-KERN: auich: codec attach
-KERN: codec reset
-KERN: auich: codec semaphore timed out!
-KERN: auich: last read/write registers: 56/0
-KERN: ac97_set_rate: clock = 48000, rate = 20000, value = 20000
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 8000, value = 8000
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 11025, value = 11025
-KERN: ac97_set_rate failed, new rate 0
-KERN: ac97_set_rate: clock = 48000, rate = 12000, value = 12000
-KERN: ac97_set_rate failed, new rate 0
---
-KERN: ac97_set_rate failed, new rate 0
-KERN: default_init
-KERN: ac97_amp_enable, reverse eamp = 0
-KERN: powerdown register was = 0x0f
-KERN: powerdown register is = 0x0f
-KERN: codec vendor id      = 0x594d4803
-KERN: codec description     = Yamaha
-KERN: codec 3d enhancement = No 3D Stereo Enhancement
-KERN: AC97 capabilities:
-KERN: CAP_DAC_18BIT
-KERN: CAP_AMAP
-KERN: CAP_REV22
-KERN: auich: installing interrupt : b
-KERN: auich: init_driver done
-KERN: auich: publish_devices()
-KERN: auich: publish audio/hmulti/auich/1
-KERN: auich: find_device(audio/hmulti/auich/1)
-KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/auich
+KERN: auich: auich_setup(0x813b57e0)
+KERN: auich: audio/hmulti/auich/1 deviceid = 0x2485 chiprev = 2 model = 1 enhanced at 0
+KERN: auich: IO space not configured
+KERN: auich: Setup of auich 1 failed
+KERN: pci_unreserve_device(0, 31, 5, auich)
+KERN: auich: no cards
+KERN: auich: no suitable cards found
 KERN: echo3g: init_hardware()
 KERN: echo3g: no card found
 KERN: sis7018:init_hardware:ver:2.0.2
 KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/emuxki
 KERN: auvia: init_hardware()
-KERN: devfs: reload driver "emuxki" (4, 10892)
-KERN: emuxki: init_hardware()
 KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/audio/hmulti/ice1712
 KERN: loaded driver /boot/system/add-ons/kernel/drivers/dev/bus/usb_raw
 KERN: firewire: fw_module_init
@@ -310,44 +355,11 @@
 KERN: firewire: found 1 cards
 KERN: firewire: latency timer 40 -> 40.
 KERN: firewire: cache size 8 -> 8.
-KERN: firewire: IRQ 11
-KERN: firewire: hardware register address fceff800
-KERN: firewire: mapping physical address 0xfceff800 with 2048 bytes for fw ohci register
-KERN: add_memory_type_range(6768, 0xfceff000, 0x1000, 0)
-KERN: set MTRRs to:
-KERN:   mtrr:  0: base:    0xee000, size:     0x1000, type: 0
-KERN:   mtrr:  1: base: 0x4ffd0000, size:    0x10000, type: 0
-KERN:   mtrr:  2: base: 0xe0000000, size: 0x20000000, type: 0
---
-KERN: PCI:   info: Mass storage controller (IDE interface)
-KERN: PCI:   line_size 00, latency 00, header_type 00, BIST 00
-KERN: PCI:   ROM base host 00000000, pci 00000000, size 00000000
-KERN: PCI:   cardbus_CIS 00000000, subsystem_id 0001, subsystem_vendor_id 1179
-KERN: PCI:   interrupt_line 0b, interrupt_pin 01, min_grant 00, max_latency 00
-KERN: PCI:   base reg 0: host 0000cff8, pci 0000cff8, size 00000008, flags 01
-KERN: PCI:   base reg 1: host 0000cff4, pci 0000cff4, size 00000004, flags 01
-KERN: PCI:   base reg 2: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   base reg 3: host 0000cfe4, pci 0000cfe4, size 00000004, flags 01
-KERN: PCI:   base reg 4: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   base reg 5: host 00000000, pci 00000000, size 00000400, flags 00
-KERN: PCI:   Capabilities: (not supported)
-KERN: PCI: [dom 0, bus  0] bus   0, device 31, function  5: vendor 8086, device 2485, revision 02
-KERN: PCI:   class_base 04, class_function 01, class_api 00
-KERN: PCI:   vendor 8086: Intel Corporation
-KERN: PCI:   device 2485: 82801CA/CAM AC'97 Audio Controller
-KERN: PCI:   info: Multimedia controller (Multimedia audio controller)
-KERN: PCI:   line_size 00, latency 00, header_type 00, BIST 00
-KERN: PCI:   ROM base host 00000000, pci 00000000, size 00000000
-KERN: PCI:   cardbus_CIS 00000000, subsystem_id 0001, subsystem_vendor_id 1179
-KERN: PCI:   interrupt_line ff, interrupt_pin 02, min_grant 00, max_latency 00
-KERN: PCI:   base reg 0: host 00000000, pci 00000000, size 00000100, flags 01
-KERN: PCI:   base reg 1: host 00000000, pci 00000000, size 00000040, flags 01
-KERN: PCI:   base reg 2: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   base reg 3: host 0000000KERN: 0, pci 00000000, size 00000000, flags 00
-KERN: PCI:   base reg 4: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   base reg 5: host 00000000, pci 00000000, size 00000000, flags 00
-KERN: PCI:   Capabilities: (not supported)
-KERN: PCI: [dom 0, bus  0] bus   0, device 31, function  6: vendor 8086, device 2486, revision 02
-KERN: PCI:   class_base 07, class_function 03, class_api 00
-KERN: PCI:   vendor 8086: Intel Corporation
-KERN: PCI:   device 2486: 82801CA/CAM AC'97 Modem Controller
+KERN: firewire: ERROR no IRQ assigned
+KERN: firewire: ERROR fwohci_pci_attach failed
+KERN: fw_raw: couldn't load bus_managers/firewire/v1
+KERN: cx23882: init_hardware()
+KERN: bfs: bfs_create_index:2124: File or Directory already exists
+Last message repeated 1 time
+KERN: devfs: reload driver "ice1712" (4, 10954)
+KERN: devfs: reload driver "emuxki" (4, 10942)