--- "Emulating Haiku in VirtualBox_V2.0.txt"	2014-11-29 18:26:55.516664359 +0100
+++ EmulatingHaikuInVirtualBox_with_guest_additons.txt	2014-11-29 22:22:31.105769739 +0100
@@ -1,14 +1,36 @@
-Virtual instances of operating systems are perfect for all kinds of testing purposes that need to be done in a safe and isolated environment. Installing Haiku in a virtual machine is a solution for people who do not want to install it on their physical computers, but wish to become familiar with it.<br />
-     
-    This How-To guide will describe the process of running Haiku on virtual machine (VM) using VirtualBox 3.2 There are two ways it can be done– one is installing and running Haiku from CD-ROM image, same way it would be done on a physical instance. Another way is using the already prepared VM hard disk image, for convenience and time-saving purposes. The choice in this decision is left up to the user, although many people prefer VM image as it is easier to manage.<br />
-For this tutorial we will be using an ISO image and VM image (vmdk) file - both can be obtained <a href="http://www.haiku-os.org/get-haiku">here</a>. The VirtualBox virtualization software and installation manual can be downloaded from <a href="http://www.virtualbox.org/wiki/Downloads">here</a>.<br />
-<br />Go to section:<ul>
-              <li>  <a href="#part_iso">Installing and running Haiku from an ISO image</a></li>
-              <li>  <a href="#part_vmimage">Running Haiku from a VM image</a></li>
-              <li>  <a href="#part_additional">Additional Steps</a></li>
-              <li>  <a href="#part_customVESA">Custom VESA Resolutions</a></li>
-              <li>  <a href="#part_trouble">Troubleshooting</a></li>
-            </ul>
+<p>Virtual instances of operating systems are perfect for all kinds of testing
+purposes that need to be done in a safe and isolated environment. Installing
+Haiku in a virtual machine is a solution for people who do not want to install
+it on their physical computers, but wish to become familiar with it.</p>
+
+<p>This How-To guide will describe the process of running Haiku on virtual
+machine (VM) using <strong>VirtualBox 3.2</strong>. We also recommend
+installing the <em>Virtualbox Guest Additions</em> that much improved
+integration of the virtual machine to the host system. They are designed to be
+installed inside a virtual machine after the guest operating system has been
+installed and consist of device drivers and system applications that optimize
+the guest operating system for better performance and usability (including
+graphical interface).</p>
+
+<p>There are two ways it can be done– one is installing and running Haiku from
+CD-ROM image, same way it would be done on a physical instance. Another way is
+using the already prepared VM hard disk image, for convenience and time-saving
+purposes. The choice in this decision is left up to the user, although many
+people prefer VM image as it is easier to manage.</p>
+
+<p>For this tutorial we will be using an ISO image and VM image (vmdk) file -
+both can be obtained <a href="http://www.haiku-os.org/get-haiku">here</a>. The
+VirtualBox virtualization software and installation manual can be downloaded
+from <a href="http://www.virtualbox.org/wiki/Downloads">here</a>.</p>
+
+<p>Go to section:</p>
+
+<ul>
+        <li><a href="#part_iso">Installing and running Haiku from an ISO image</a></li>
+        <li><a href="#part_vmimage">Running Haiku from a VM image</a></li>
+        <li><a href="#part_additional">Additional Steps</a></li>
+        <li><a href="#part_trouble">Troubleshooting</a></li>        
+</ul>
              
             <h3 id="part_iso">Installing and running Haiku from an ISO image.</h3>
              
@@ -116,21 +138,52 @@
             One of the ways to increase performance if changing the video memory assigned to the virtual machine. On the left panel click Display tab, and move the first slider to the right, to increase the amount of memory assigned. This should allow the GUI to run more smoothly and be more responsive.  
              
             <br /><img style="padding:12px" alt="Display tab" src="https://www.haiku-os.org/files/image15.png"/><br />
-             
-            Another hint is to enable the hardware virtualization, which by default is disabled. On the System page, click the Processor tab and mark Enable PAE/NX to enable CPU address extension.
+
+            <p>If you have previously installed Virtualbox Guest Additions,
+you can benefit from better management of the mouse between the host and the
+VM especially if it is USB or you have more than one.</p>
+
+            <p>Go to settings of your VM. On the <em>System</em> page and
+<em>Motherboard</em> tab, choose pointing device: <em>USB Tablet</em> (That
+should fix the problem).</p>
+
+            <p>Another hint is to enable the hardware virtualization, which
+by default is disabled. On the System page, click the Processor tab and mark
+Enable PAE/NX to enable CPU address extension. Before enabling this option,
+make sure your CPU supports it by visiting the manufacturer's information
+page. If you're running Linux, you can see the output of the command:<p>
+
+<pre class="terminal">grep ^flags /proc/cpuinfo</pre>
+
+            <p>This list must contain flags pae and/or nx.</p>
              
             <br /><img style="padding:12px" alt="Settings tab" src="https://www.haiku-os.org/files/image16.png"/><br />
              
             After you are done with configuration, click <span class="button">OK</span> to move back to the main window.
             <!--break-->
             <h5>Additional Step 2. Adjusting window settings.</h5>
-            One of the inconveniences users experience while using virtual machines are screen resolutions. By default, guest OS’s apply a big screen resolution, causing the windows to have scrolling bars on both sides to navigate in x-axis and y-axis. There are two solutions for that problem.<br />
-             
-            First solution is simply adjusting the screen resolution using tools built into system. In Haiku we can use the Screen preflet, which can be found under the Preferences menu. By changing the resolution the user will then notice that size of the VM window has now changed.
+            <p>One of the inconveniences users experience while using virtual
+machines are screen resolutions. By default, guest OS’s apply a big screen
+resolution, causing the windows to have scrolling bars on both sides to
+navigate in x-axis and y-axis. There are two solutions for that problem.</p>
+
+            <p>First solution is simply adjusting the screen resolution using
+tools built into system. In Haiku we can use the Screen preflet, which can be
+found under the Preferences menu. By changing the resolution the user will
+then notice that size of the VM window has now changed.</p>
              
             <br /><img style="padding:12px" alt="Haiku's Screen Preflet" src="https://www.haiku-os.org/files/image17.png"/><br />
-             
-            Another way, is to install VirtualBox Guest Additions. They are designed to be installed inside a virtual machine after the guest operating system has been installed and consist of device drivers and system applications that optimize the guest operating system for better performance and usability (including graphical interface).  Unfortunately, there is no support for Guest Additions for Haiku yet, meaning for now the GUI needs to be controlled using system tools.  As soon as Guest Additions for Haiku will be released, this guide will be updated. For now that is the only way to solve that problem.
+
+            <p>You can optionally add a custom VESA resolution to the VM to get the
+full screen mode:</p>
+
+            <pre class="terminal">VBoxManage setextradata "NameOfYourVM" "CustomVideoMode1" "1400x1050x16"</pre>
+
+            </p>Another way, is to install <em>VirtualBox Guest
+Additions</em>. You can then enter and exit the full screen mode with the
+<span class="key">Host</span> + <span class="key">F</span> toggle.</p>
+
+
             <!--break-->
             <h5>Additional Step 3. Expanding the size of the VM hard disk image.</h5>
             Often users find the size of original VM Haiku image not big enough to fulfil their needs. By default that size is about 600mb and in this step we are going to expand it. There is a way to do it, but it’s not as easy as it sounds. Just like a regular hard drive, once created, its physical boundaries cannot be expanded any more (the size of the disk, not partitions). The solution could be reinstalling, or cloning  the content of smaller hard drive into bigger one. That is exactly what we can do in this situation.<br />
@@ -145,12 +198,20 @@
              
             Click <span class="button">Finish</span> to confirm action.<br />
              
-            For the next step we will need to switch to the command-line environment, to perform the cloning process. These steps need to be done on the host OS. Depending on OS installed instructions may vary (see <a href="http://www.virtualbox.org/manual/ch08.html">here</a> to get more information). Open the terminal/console and navigate to the location where VirtualBox was installed and run the following command:
+            <p>For the next step we will need to switch to the command-line
+environment, to perform the cloning process. These steps need to be done on
+the host OS. Depending on OS installed instructions may vary (see <a
+href="http://www.virtualbox.org/manual/ch08.html">here</a> to get more
+information). Open the terminal/console and navigate to the location where
+VirtualBox was installed and run the following command:</p>
              
             <pre class="terminal">VBoxManage clonehd [location of .vdmk VM hard drive image] [location of hard drive we created earlier] –-existing</pre>
-            for example: (Windows host platform)
+
+            <p>F or example: (Windows host platform)</p>
+
             <pre class="terminal">“C:\Program Files\Oracle\VirtualBox\VBoxManage.exe” clonehd C:\haiku-r1alpha2.vmdk C:\new.vdi --existing</pre>
-            After executing this instruction the progress calculator will appear and return the uuid when finished.
+            <p>After executing this instruction the progress calculator will
+appear and return the uuid when finished.</p>
              
             <br /><img style="padding:12px" alt="CMD output" src="https://www.haiku-os.org/files/image20.png"/><br />
              
@@ -159,17 +220,12 @@
             <br /><img style="padding:12px" alt="With the new image" src="https://www.haiku-os.org/files/image21.png"/><br />
              
             After the process if completed, we can delete the old, smaller hard drive VM image, and boot the new one we have just created.
-            <!--break-->
-            <hr />
-                    <h3 id="part_customVESA">Custom VESA Resolutions</h3>
 
-            Example:
-            <pre class="terminal">VBoxManage setextradata "VM name" "CustomVideoMode1" "1400x1050x16"</pre>
             <!--break-->
             <hr />
-
-                    <h3 id="part_trouble">Troubleshooting</h3>
+            <h3 id="part_trouble">Troubleshooting</h3>
             <!--break-->
+
             <h5> 1. Haiku cannot connect to the internet</h5>
             There are some known issues with the network cards on VirtualBox virtual machines. The symptom is simply the inability to connect to other computers over the Internet. A solution to this problem is as follows:<br />
              
@@ -178,7 +234,3 @@
             <br /><img style="padding:12px" alt="Intel PRO/100 MT" src="https://www.haiku-os.org/files/image22.png"/><br />
              
             Now the network services should be working properly.  
-            <!--break-->
-            <h5>2. USB mice are not working in Haiku when using a Virtual Machine</h5>
-             
-            Sometimes when there is more than one pointing device installed on the host OS, the secondary devices does not fully cooperate with Haiku VM. This is a known issue which can be easily fixed by the use of Virtualbox Guest Additions, as it is connected to mouse integration. Because Guest Additions for Haiku are not implemented yet, the only solution for that problem is to keep on using the primary pointing device, or make the USB mouse the main pointing device. This should be fixed as soon as Guest Additions for Haiku are officially released, but for now, there is no easy way to solve this issue.