diff --git a/headers/private/graphics/common/video_configuration.h b/headers/private/graphics/common/video_configuration.h
index e565d97..3f2f3c9 100644
--- a/headers/private/graphics/common/video_configuration.h
+++ b/headers/private/graphics/common/video_configuration.h
@@ -13,29 +13,35 @@
 
 
 // Video connector types
-#define VIDEO_CONNECTOR_UNKNOWN 	0x00
-#define VIDEO_CONNECTOR_VGA			0x01
-#define VIDEO_CONNECTOR_DVII		0x02
-#define VIDEO_CONNECTOR_DVID		0x03
-#define VIDEO_CONNECTOR_DVIA		0x04
-#define VIDEO_CONNECTOR_COMPOSITE	0x05
-#define VIDEO_CONNECTOR_SVIDEO		0x06
-#define VIDEO_CONNECTOR_LVDS		0x07
-#define VIDEO_CONNECTOR_COMPONENT	0x08
-#define VIDEO_CONNECTOR_9DIN		0x09
-#define VIDEO_CONNECTOR_DP			0x0A
-#define VIDEO_CONNECTOR_EDP			0x0B
-#define VIDEO_CONNECTOR_HDMIA		0x0C
-#define VIDEO_CONNECTOR_HDMIB		0x0D
-#define VIDEO_CONNECTOR_TV			0x0E
+enum video_connector {
+	VIDEO_CONNECTOR_ANY,
+	VIDEO_CONNECTOR_UNKNOWN,
+	VIDEO_CONNECTOR_VGA,
+	VIDEO_CONNECTOR_DVII,
+	VIDEO_CONNECTOR_DVID,
+	VIDEO_CONNECTOR_DVIA,
+	VIDEO_CONNECTOR_COMPOSITE,
+	VIDEO_CONNECTOR_SVIDEO,
+	VIDEO_CONNECTOR_LVDS,
+	VIDEO_CONNECTOR_COMPONENT,
+	VIDEO_CONNECTOR_9DIN,
+	VIDEO_CONNECTOR_DP,
+	VIDEO_CONNECTOR_EDP,
+	VIDEO_CONNECTOR_HDMI,
+	VIDEO_CONNECTOR_TV,
+	VIDEO_CONNECTOR_HDMIB,
+		// TODO: remove from radeon_hd, do not use.
+};
 
 
 // Video encoder types
-#define VIDEO_ENCODER_NONE		0x00
-#define VIDEO_ENCODER_DAC		0x01
-#define VIDEO_ENCODER_TMDS		0x02
-#define VIDEO_ENCODER_LVDS		0x03
-#define VIDEO_ENCODER_TVDAC		0x04
+enum video_encoder {
+	VIDEO_ENCODER_NONE,
+	VIDEO_ENCODER_DAC,
+	VIDEO_ENCODER_TMDS,
+	VIDEO_ENCODER_LVDS,
+	VIDEO_ENCODER_TVDAC,
+};
 
 
 // to ensure compatibility with C accelerants
@@ -45,8 +51,8 @@ extern "C" {
 
 
 // mostly for debugging detected monitors
-const char* get_connector_name(uint32 connector);
-const char* get_encoder_name(uint32 encoder);
+const char* get_connector_name(video_connector type);
+const char* get_encoder_name(video_encoder type);
 
 
 #ifdef __cplusplus
diff --git a/src/add-ons/accelerants/common/video_configuration.cpp b/src/add-ons/accelerants/common/video_configuration.cpp
index a6ed5bd..fe2ecca 100644
--- a/src/add-ons/accelerants/common/video_configuration.cpp
+++ b/src/add-ons/accelerants/common/video_configuration.cpp
@@ -1,5 +1,5 @@
 /*
- * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Copyright 2011-2016, Haiku, Inc. All Rights Reserved.
  * Distributed under the terms of the MIT License.
  *
  * Authors:
@@ -14,9 +14,13 @@
 
 
 const char*
-get_connector_name(uint32 connector)
+get_connector_name(video_connector type)
 {
-	switch (connector) {
+	switch (type) {
+		case VIDEO_CONNECTOR_ANY:
+			return "Generic";
+		case VIDEO_CONNECTOR_UNKNOWN:
+			return "Unknown";
 		case VIDEO_CONNECTOR_VGA:
 			return "VGA";
 		case VIDEO_CONNECTOR_DVII:
@@ -39,23 +43,21 @@ get_connector_name(uint32 connector)
 			return "DisplayPort";
 		case VIDEO_CONNECTOR_EDP:
 			return "Embedded DisplayPort";
-		case VIDEO_CONNECTOR_HDMIA:
-			return "HDMI A";
+		case VIDEO_CONNECTOR_HDMI:
+			return "HDMI";
 		case VIDEO_CONNECTOR_HDMIB:
 			return "HDMI B";
 		case VIDEO_CONNECTOR_TV:
 			return "TV";
-		case VIDEO_CONNECTOR_UNKNOWN:
-			return "Unknown";
 	}
 	return "Undefined";
 }
 
 
 const char*
-get_encoder_name(uint32 encoder)
+get_encoder_name(video_encoder type)
 {
-	switch (encoder) {
+	switch (type) {
 		case VIDEO_ENCODER_NONE:
 			return "None";
 		case VIDEO_ENCODER_DAC:
diff --git a/src/add-ons/accelerants/radeon_hd/accelerant.h b/src/add-ons/accelerants/radeon_hd/accelerant.h
index 94c43a6..496a2a7 100644
--- a/src/add-ons/accelerants/radeon_hd/accelerant.h
+++ b/src/add-ons/accelerants/radeon_hd/accelerant.h
@@ -12,6 +12,7 @@
 
 #include <ByteOrder.h>
 #include <edid.h>
+#include <video_configuration.h>
 
 #include "atom.h"
 #include "dp.h"
@@ -141,28 +142,28 @@ typedef struct {
 
 
 struct encoder_info {
-	bool		valid;
-	uint16		objectID;
-	uint32		type;
-	uint32		capabilities;
-	uint32		linkEnumeration; // ex. linkb == GRAPH_OBJECT_ENUM_ID2
-	bool		isExternal;
-	bool		isDPBridge;
+	bool			valid;
+	uint16			objectID;
+	video_encoder	type;
+	uint32			capabilities;
+	uint32			linkEnumeration; // ex. linkb == GRAPH_OBJECT_ENUM_ID2
+	bool			isExternal;
+	bool			isDPBridge;
 	struct pll_info	pll;
 };
 
 
 typedef struct {
-	bool		valid;
-	uint16		objectID;
-	uint32		type;
-	uint32		flags;
-	uint32		lvdsFlags;
-	uint16		i2cPinIndex; // id of gpio pin for i2c communications
-	uint16		hpdPinIndex; // id of gpio pin for hotplug detection
+	bool			valid;
+	uint16			objectID;
+	video_connector type;
+	uint32			flags;
+	uint32			lvdsFlags;
+	uint16			i2cPinIndex; // id of gpio pin for i2c communications
+	uint16			hpdPinIndex; // id of gpio pin for hotplug detection
 	struct encoder_info encoder;
 	struct encoder_info encoderExternal;
-	dp_info		dpInfo;
+	dp_info			dpInfo;
 } connector_info;
 
 
diff --git a/src/add-ons/accelerants/radeon_hd/connector.cpp b/src/add-ons/accelerants/radeon_hd/connector.cpp
index 3ab6527..1efcb7f 100644
--- a/src/add-ons/accelerants/radeon_hd/connector.cpp
+++ b/src/add-ons/accelerants/radeon_hd/connector.cpp
@@ -703,7 +703,7 @@ connector_probe()
 		path = (ATOM_DISPLAY_OBJECT_PATH*)address;
 		pathSize += B_LENDIAN_TO_HOST_INT16(path->usSize);
 
-		uint32 connectorType;
+		video_connector connectorType;
 		uint16 connectorFlags = B_LENDIAN_TO_HOST_INT16(path->usDeviceTag);
 
 		if ((deviceSupport & connectorFlags) != 0) {
@@ -794,8 +794,8 @@ connector_probe()
 								= (encoderObjectRaw & OBJECT_ID_MASK)
 									>> OBJECT_ID_SHIFT;
 
-							uint32 encoderType = encoder_type_lookup(encoderID,
-								connectorFlags);
+							video_encoder encoderType = encoder_type_lookup(
+								encoderID, connectorFlags);
 
 							if (encoderType == VIDEO_ENCODER_NONE) {
 								ERROR("%s: Path #%" B_PRId32 ":"
@@ -919,7 +919,7 @@ debug_connectors()
 	ERROR("Currently detected connectors=============\n");
 	for (uint32 id = 0; id < ATOM_MAX_SUPPORTED_DEVICE; id++) {
 		if (gConnector[id]->valid == true) {
-			uint32 connectorType = gConnector[id]->type;
+			video_connector connectorType = gConnector[id]->type;
 			uint16 i2cPinIndex = gConnector[id]->i2cPinIndex;
 			uint16 hpdPinIndex = gConnector[id]->hpdPinIndex;
 
diff --git a/src/add-ons/accelerants/radeon_hd/connector.h b/src/add-ons/accelerants/radeon_hd/connector.h
index 1b95e04..b3feb89 100644
--- a/src/add-ons/accelerants/radeon_hd/connector.h
+++ b/src/add-ons/accelerants/radeon_hd/connector.h
@@ -15,7 +15,7 @@
 
 
 // convert radeon connector to common connector type
-const int kConnectorConvertLegacy[] = {
+const video_connector kConnectorConvertLegacy[] = {
 	VIDEO_CONNECTOR_UNKNOWN,
 	VIDEO_CONNECTOR_VGA,
 	VIDEO_CONNECTOR_DVII,
@@ -26,7 +26,7 @@ const int kConnectorConvertLegacy[] = {
 	VIDEO_CONNECTOR_LVDS,
 	VIDEO_CONNECTOR_UNKNOWN,
 	VIDEO_CONNECTOR_UNKNOWN,
-	VIDEO_CONNECTOR_HDMIA,
+	VIDEO_CONNECTOR_HDMI,
 	VIDEO_CONNECTOR_HDMIB,
 	VIDEO_CONNECTOR_UNKNOWN,
 	VIDEO_CONNECTOR_UNKNOWN,
@@ -34,7 +34,7 @@ const int kConnectorConvertLegacy[] = {
 	VIDEO_CONNECTOR_DP
 };
 
-const int kConnectorConvert[] = {
+const video_connector kConnectorConvert[] = {
 	VIDEO_CONNECTOR_UNKNOWN,
 	VIDEO_CONNECTOR_DVII,
 	VIDEO_CONNECTOR_DVII,
@@ -47,7 +47,7 @@ const int kConnectorConvert[] = {
 	VIDEO_CONNECTOR_UNKNOWN,
 	VIDEO_CONNECTOR_9DIN,
 	VIDEO_CONNECTOR_UNKNOWN,
-	VIDEO_CONNECTOR_HDMIA,
+	VIDEO_CONNECTOR_HDMI,
 	VIDEO_CONNECTOR_HDMIB,
 	VIDEO_CONNECTOR_LVDS,
 	VIDEO_CONNECTOR_9DIN,
diff --git a/src/add-ons/accelerants/radeon_hd/display.cpp b/src/add-ons/accelerants/radeon_hd/display.cpp
index 5555756..a107c44 100644
--- a/src/add-ons/accelerants/radeon_hd/display.cpp
+++ b/src/add-ons/accelerants/radeon_hd/display.cpp
@@ -417,8 +417,9 @@ debug_displays()
 		uint32 connectorIndex = gDisplay[id]->connectorIndex;
 
 		if (gDisplay[id]->attached) {
-			uint32 connectorType = gConnector[connectorIndex]->type;
-			uint32 encoderType = gConnector[connectorIndex]->encoder.type;
+			video_connector connectorType = gConnector[connectorIndex]->type;
+			video_encoder encoderType
+				= gConnector[connectorIndex]->encoder.type;
 			ERROR(" + connector ID:   %" B_PRIu32 "\n", connectorIndex);
 			ERROR(" + connector type: %s\n", get_connector_name(connectorType));
 			ERROR(" + encoder type:   %s\n", get_encoder_name(encoderType));
@@ -477,7 +478,7 @@ display_get_encoder_mode(uint32 connectorIndex)
 				return ATOM_ENCODER_MODE_CRT;
 			break;
 		case VIDEO_CONNECTOR_DVID:
-		case VIDEO_CONNECTOR_HDMIA:
+		case VIDEO_CONNECTOR_HDMI:
 		default:
 			// TODO: if audio detected on edid and DCE4, ATOM_ENCODER_MODE_DVI
 			//        if audio detected on edid not DCE4, ATOM_ENCODER_MODE_HDMI
diff --git a/src/add-ons/accelerants/radeon_hd/encoder.cpp b/src/add-ons/accelerants/radeon_hd/encoder.cpp
index 72a123e..020a263 100644
--- a/src/add-ons/accelerants/radeon_hd/encoder.cpp
+++ b/src/add-ons/accelerants/radeon_hd/encoder.cpp
@@ -444,7 +444,7 @@ encoder_digital_setup(uint32 connectorIndex, uint32 pixelClock, int command)
 	uint32 lvdsFlags = gConnector[connectorIndex]->lvdsFlags;
 
 	bool isHdmi = false;
-	if (gConnector[connectorIndex]->type == VIDEO_CONNECTOR_HDMIA
+	if (gConnector[connectorIndex]->type == VIDEO_CONNECTOR_HDMI
 		|| gConnector[connectorIndex]->type == VIDEO_CONNECTOR_HDMIB) {
 		isHdmi = true;
 	}
@@ -2098,7 +2098,7 @@ encoder_object_lookup(uint32 connectorFlags, uint8 dacID)
 }
 
 
-uint32
+video_encoder
 encoder_type_lookup(uint32 encoderID, uint32 connectorFlags)
 {
 	switch (encoderID) {
diff --git a/src/add-ons/accelerants/radeon_hd/encoder.h b/src/add-ons/accelerants/radeon_hd/encoder.h
index 8db3f50..b7924a0 100644
--- a/src/add-ons/accelerants/radeon_hd/encoder.h
+++ b/src/add-ons/accelerants/radeon_hd/encoder.h
@@ -1,5 +1,5 @@
 /*
- * Copyright 2006-2011, Haiku, Inc. All Rights Reserved.
+ * Copyright 2006-2016, Haiku, Inc. All Rights Reserved.
  * Distributed under the terms of the MIT License.
  *
  * Authors:
@@ -10,6 +10,8 @@
 
 
 #include <SupportDefs.h>
+#include <video_configuration.h>
+
 
 void encoder_init();
 
@@ -43,7 +45,7 @@ void encoder_dpms_set_external(uint8 crtcID, int mode);
 
 const char* encoder_name_lookup(uint32 encoderID);
 uint32 encoder_object_lookup(uint32 connectorFlags, uint8 dacID);
-uint32 encoder_type_lookup(uint32 encoderID, uint32 connectorFlags);
+video_encoder encoder_type_lookup(uint32 encoderID, uint32 connectorFlags);
 bool encoder_is_external(uint32 encoderID);
 bool encoder_is_dp_bridge(uint32 encoderID);
 